VGA_CRTC		equ 03d4h
VGA_CURSOR_LOC_HIGH	equ 0eh
VGA_CURSOR_LOC_LOW	equ 0fh

;--------------------------------------------------------------------

print_char_32:
;void print_char_32 (char c, int attrib);
;

%define	c ebp+8
%define	attrib ebp+12

	push	ebp
	mov	ebp,esp
	
	push	eax
	push	ebx
	push	ecx

	call	get_cursor_pos

	mov	bl,byte [c]
	cmp	bl,10
	je	short .newline
	
	mov	bh,byte [attrib]

	mov	word [0xB8000+eax*2],bx
	
	inc	eax
	jmp	.update_cursor

.newline:
	mov	ebx,eax
	xor	edx,edx
	mov	ecx,80
	div	ecx
	xor	edx,edx
	inc	eax
	mul	ecx

.update_cursor:
	cmp	eax,80*25
	jb	short .set_cursor
	
	call	scroll_up
	sub	eax,80

.set_cursor:
	push	eax
	call	set_cursor_pos
	
	pop	ecx
	pop	ebx
	pop	eax
	
	mov	esp,ebp
	pop	ebp

	ret	8

;--------------------------------------------------------------------

get_cursor_pos:
;int get_cursor_pos();
;
	push	edx

	xor	eax,eax

	mov	al,VGA_CURSOR_LOC_HIGH
	mov	edx,VGA_CRTC
	out	dx,al
	inc	edx
	in	al,dx
	mov	ah,al

	mov	al,VGA_CURSOR_LOC_LOW
	dec	edx
	out	dx,al
	inc	edx
	in	al,dx
	
	pop	edx
	
	ret

;--------------------------------------------------------------------

set_cursor_pos:
;void set_cursor_pos(int pos);
;

%define	pos ebp+8

	push	ebp
	mov	ebp,esp
	
	push	eax
	push	ebx
	push	edx
	
	mov	ebx,dword [pos]

	mov	al,VGA_CURSOR_LOC_HIGH
	mov	dx,VGA_CRTC
	mov	ah,bh
	out	dx,ax

	mov	al,VGA_CURSOR_LOC_LOW
	mov	ah,bl
	out	dx,ax
	
	pop	edx
	pop	ebx
	pop	eax
	
	mov	esp,ebp
	pop	ebp

	ret	4

;--------------------------------------------------------------------

scroll_up:
;void scroll_up();
;

	push	eax
	push	ecx
	push	esi
	push	edi

	mov	esi,0xB8000+(80*2)
	mov	edi,0xB8000
	mov	ecx,(80*2)*24
	rep	movsb
	mov	eax,0x0720
	mov	ecx,80
	rep	stosw
	
	pop	edi
	pop	esi
	pop	ecx
	pop	eax
	
	ret
